commit abd47b4abea7e1463706c1132dc78d468d27bd96
Author: Iain Buclaw <ibuclaw@gdcproject.org>
Date:   Mon Jul 26 17:06:08 2021

    d: Insert null terminator in obstack buffers
    
    Covers cases where functions that handle the extracted strings ignore
    the explicit length.  This isn't something that's known to happen in the
    current front-end, but the self-hosted front-end has been observed to do
    this in its conversions between D and C-style strings.
    
    gcc/d/ChangeLog:
    
            * d-lang.cc (deps_add_target): Insert null terminator in buffer.
            (deps_write): Likewise.
            (d_parse_file): Likewise.
    
    (cherry picked from commit b2abe4e1aded1409964b870899d18dfdb6384821)

diff --git a/gcc/d/d-lang.cc b/gcc/d/d-lang.cc
index 6ad3823d910..3e6566a3689 100644
--- a/gcc/d/d-lang.cc
+++ b/gcc/d/d-lang.cc
@@ -108,7 +108,7 @@ deps_add_target (const char *target, bool quoted)
 
   if (!quoted)
     {
-      obstack_grow (&buffer, target, strlen (target));
+      obstack_grow0 (&buffer, target, strlen (target));
       d_option.deps_target.safe_push ((const char *) obstack_finish (&buffer));
       return;
     }
@@ -149,6 +149,7 @@ deps_add_target (const char *target, bool quoted)
       obstack_1grow (&buffer, *p);
     }
 
+  obstack_1grow (&buffer, '\0');
   d_option.deps_target.safe_push ((const char *) obstack_finish (&buffer));
 }
 
@@ -278,6 +279,8 @@ deps_write (Module *module, obstack *buffer)
       obstack_grow (buffer, str, strlen (str));
       obstack_grow (buffer, ":\n", 2);
     }
+
+  obstack_1grow (buffer, '\0');
 }
 
 /* Implements the lang_hooks.init_options routine for language D.
@@ -884,6 +887,7 @@ d_parse_file (void)
 	      obstack_grow (&buffer, str, strlen (str));
 	    }
 
+	  obstack_1grow (&buffer, '\0');
 	  message ("%s", (char *) obstack_finish (&buffer));
 	}
     }

